#include <bits/stdc++.h>

using namespace std;


void add(vector<int>& tree, int k, int val) {
    k += tree.size() / 2;
    tree[k] += val;
    for(k /= 2; k >= 1; k /= 2) tree[k] = tree[2*k] + tree[2*k+1];
}

void segment_tree(const vector<int>& array, vector<int>& tree) {
    int size = 1;
    while(size < array.size()) size *= 2;
    tree.resize(size * 2);
    for(int i = 0; i < array.size(); i++) add(tree, i, array[i]);
}

int sumq(const vector<int>& tree, int a, int b) {
    a += tree.size() / 2;
    b += tree.size() / 2;
    int res = 0;
    for(; a <= b; a /= 2, b /= 2) {
        if(a % 2 == 1) res += tree[a++];
        if(b % 2 == 0) res += tree[b--];
    }
    return res;
}

int main() {
    vector<int> array = {5, 8, 6, 3, 2, 7, 2, 6};
    
    vector<int> tree;
    segment_tree(array, tree);
    
    cout << sumq(tree, 2, 7) << endl;
    
    return 0;
}
